## mingw-w64-python-cx-freeze-8.6.0-1.src.tar.zst

=== Makefile ===
# Makefile to automate some tools
SHELL=/bin/bash
PATH := $(shell python -c "import sysconfig; print(sysconfig.get_path('scripts'))"):$(PATH)

PY_PLATFORM := $(shell python -c "import sysconfig; print(sysconfig.get_platform())")
PRE_COMMIT_OPTIONS := --show-diff-on-failure --color=always --all-files --hook-stage=manual --no-progress

COV_TMPDIR := $(shell mktemp -d)

.PHONY: all
all: install

.PHONY: prek
prek: install
	@(prek run $(PRE_COMMIT_OPTIONS) || true) | more
	@prek cache gc -q

.PHONY: pylint
pylint:
	uvx pylint cx_Freeze

.PHONY: clean
clean: uninstall
	@$(MAKE) -C doc clean
	@rm -f .coverage* || true
	@rm -rf build dist wheelhouse
	@prek cache clean -q

.PHONY: install
install:
	./ci/install-tools.sh --dev
	if ! [ -f .git/hooks/pre-commit ]; then\
		prek install --install-hooks --overwrite -t pre-commit;\
	fi

.PHONY: uninstall
uninstall:
	@prek uninstall -q
	@rm -f .git/hooks/pre-commit

.PHONY: upgrade
upgrade: install
	prek auto-update
	$(MAKE) prek

.PHONY: html
html:
	@if [ -f .git/hooks/pre-commit ]; then\
		prek run blacken-docs $(PRE_COMMIT_OPTIONS);\
		prek run build-docs $(PRE_COMMIT_OPTIONS);\
	else\
		$(MAKE) -C doc html;\
	fi

.PHONY: htmltest
htmltest:
	$(MAKE) -C doc test

.PHONY: doc
doc:
	$(MAKE) -C doc html
	$(MAKE) -C doc epub
	$(MAKE) -C doc pdf

.PHONY: wheel
wheel:
	./ci/build-wheel.sh --install

.PHONY: tests
tests: wheel
	./ci/install-tools.sh --tests
	cp pyproject.toml $(COV_TMPDIR)/
	cp -a samples $(COV_TMPDIR)/
	cp -a tests $(COV_TMPDIR)/
	cd $(COV_TMPDIR) && pytest --dist=loadfile -nauto -v -rpfEsXx tests|| true

.PHONY: cov
cov: wheel
	./ci/install-tools.sh --tests
	@rm -rf build/coverage_html_report
	cp pyproject.toml $(COV_TMPDIR)/
	cp -a samples $(COV_TMPDIR)/
	cp -a tests $(COV_TMPDIR)/
	cd $(COV_TMPDIR) && coverage run ||true
	coverage combine --keep --quiet -a $(COV_TMPDIR)/
	coverage report
	coverage html

=== requirements.txt ===
freeze-core>=0.6.0
packaging>=25.0
setuptools>=78.1.1,<=82.0
tomli>=2.0.1 ;python_version == '3.10'
filelock>=3.20.3 ;sys_platform == 'linux'
patchelf>=0.16.1,<0.18 ;sys_platform == 'linux' and platform_machine == 'x86_64'
patchelf>=0.16.1,<0.18 ;sys_platform == 'linux' and platform_machine == 'i686'
patchelf>=0.16.1,<0.18 ;sys_platform == 'linux' and platform_machine == 'aarch64'
patchelf>=0.16.1,<0.18 ;sys_platform == 'linux' and platform_machine == 'armv7l'
patchelf>=0.16.1,<0.18 ;sys_platform == 'linux' and platform_machine == 'ppc64le'
patchelf>=0.16.1,<0.18 ;sys_platform == 'linux' and platform_machine == 's390x'
dmgbuild>=1.6.1 ;sys_platform == 'darwin'
lief>=0.15.1,<=0.17.3 ;sys_platform == 'win32' and platform_machine != 'ARM64'
lief>=0.15.1,<=0.17.3 ;sys_platform == 'win32' and platform_machine == 'ARM64' and python_version <= '3.13'
python-msilib>=0.4.1 ;sys_platform == 'win32' and python_version >= '3.13'

=== doc/requirements.txt ===
sphinx==9.1.0
sphinx-inline-tabs==2025.12.21.14
sphinx-issues==5.0.1
sphinx-new-tab-link==0.8.1
furo==2025.12.19
myst-parser==5.0.0

=== tests/requirements.txt ===
coverage==7.13.4
filelock>=3.20.3
pytest==9.0.2
pluggy==1.6.0
pytest-mock==3.15.1
pytest-timeout==2.4.0
pytest-xdist==3.8.0

=== PKGBUILD ===
# Maintainer: Marcelo Duarte @marcelotduarte
# Maintainer: Frode Solheim <frode@fs-uae.net>
# Contributor: Duong Pham <dthpham@gmail.com>
# Contributor: Lara Maia <dev@lara.click>

_realname=cx-freeze
pkgbase=mingw-w64-python-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-python-${_realname}")
pkgver=8.6.0
pkgrel=1
pkgdesc="Creates standalone executables from Python scripts with the same performance as the original script (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/marcelotduarte/cx_Freeze/"
msys2_repository_url='https://github.com/marcelotduarte/cx_Freeze'
msys2_references=(
  'purl: pkg:pypi/cx-freeze'
)
license=('spdx:PSF-2.0')
depends=(
  "${MINGW_PACKAGE_PREFIX}-python"
  "${MINGW_PACKAGE_PREFIX}-python-packaging"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-python-lief"
  "${MINGW_PACKAGE_PREFIX}-python-freeze-core"
  "${MINGW_PACKAGE_PREFIX}-python-msilib"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
)
optdepends=(
  "${MINGW_PACKAGE_PREFIX}-python-cx-logging"
)
checkdepends=(
  "${MINGW_PACKAGE_PREFIX}-python-pip"
  "${MINGW_PACKAGE_PREFIX}-python-coverage"
  "${MINGW_PACKAGE_PREFIX}-python-pytest"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-mock"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-timeout"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-xdist"
)
options=(!strip)
source=(
  "https://pypi.org/packages/source/${_realname::1}/${_realname/-/_}/${_realname/-/_}-${pkgver}.tar.gz"
  #"${url}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
)
sha256sums=(
  "04de4e97a0fbebf5c67aec74ecd62c206f282163a111cda4343367d653b2c46d"
)

prepare() {
  cd cx_freeze-${pkgver}
  # ignore version check for setuptools
  sed -i 's/"setuptools>=.*"/"setuptools"/' pyproject.toml

  rm -Rf "${srcdir}"/python-${_realname}-${MSYSTEM}
  cp -a "${srcdir}"/cx_freeze-${pkgver} "${srcdir}"/python-${_realname}-${MSYSTEM}
}

build() {
  cd python-${_realname}-${MSYSTEM}
  python -m build --wheel --skip-dependency-check --no-isolation
}

check() {
  cd python-${_realname}-${MSYSTEM}
  pip install cx_Freeze -f dist --no-deps --no-index
  coverage run
}

package() {
  cd python-${_realname}-${MSYSTEM}
  MSYS2_ARG_CONV_EXCL="--prefix=" \
    python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" dist/*.whl
  install -Dm644 LICENSE.md "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}/LICENSE.md"
}
